module srisc1(clock,pc,data,reset,da,db,dc,ra,rb,rc);
input clock,reset;
output [7:0] pc;
output [31:0] data;
output [31:0] da,db,dc;
output [4:0] ra,rb,rc;

wire write_enable;
assign write_enable = 1'b1;

reg [7:0] pc;

// instantiate memory
inst inst_cache(
	.address(pc),
	.clock(clock),
	.q(data)
);


// instantiate register file
reg_file regs(
	.clock(clock),
	.reset(reset),
	.da(da),
	.db(db),
	.dc(dc),
	.ra(ra),
	.rb(rb),
	.rc(rc),
	.write_enable(write_enable)
	);


always @(posedge clock)
begin
	pc <= pc + 8'h01;
end

wire [5:0] op, opx;
wire [15:0] immed;
assign op = data[5:0];
assign ra = data[31:27];
assign rb = data[26:22];
assign opx = data[16:11];
assign shf = data[10:6];
assign immed = data[21:6];

wire iflag;
assign iflag = (op!=6'h3a);
assign rc = (iflag? rb: data[21:17]);
assign dc = (iflag? {16'h0000,immed}: da);


endmodule
